VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSTY"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
'       hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
'
'
'Private Type udtHeader
'    bArray(55) As Byte
'End Type
'
'Private Type udtPalette
'    bArray(1023) As Byte
'End Type

'Private Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" _
'        (Destination As Any, Source As Any, ByVal Length As Long)

Private NumOfTiles As Integer
Private NumOfPals As Integer
Private NumOfPalx As Integer
Private NumOfSprx As Integer
Private NumOfFonb As Integer
Private NumOfSprb As Integer
Private LenOfDelx As Long
Private LenOfDels As Long
Private LenOfCari As Long

Private m_Trans As Boolean
Private m_Width As Long
Private m_Height As Long
Private m_Pal As Integer

Private Tiles() As tTile
Public Sprg As String
Private Sprx() As tSprx
Private Obji As String
Private Spec As String

Private bTile As Boolean
Private bPpal As Boolean
Private bPalx As Boolean
Private bPalb As Boolean
Private bSprg As Boolean
Private bSprx As Boolean
Private bSprb As Boolean
Private bDels As Boolean
Private bDelx As Boolean
Private bFonb As Boolean
Private bCari As Boolean
Private bObji As Boolean
Private bRecy As Boolean
Private bSpec As Boolean

Public Sub LoadSTY(sFile)
    Dim length As Long
    Dim tmp As String
    Dim i As Integer
    Dim f As String
    Dim Header As String
    Dim head As String
    Dim iTmp As Long
    Dim z As Long
    Dim h As Long
    Dim c As Long
    Dim X As Long
    Dim e As Long
    
    ResetStuff
    f = FreeFile
    If Dir(sFile, vbHidden + vbSystem + vbArchive + vbNormal) = vbNullString Then
        Call MsgBox("STY file not found " & sFile & ". You need to select a STY file in the map editor.", vbExclamation, App.Title)
        End
    End If
    
    Open sFile For Binary As f
        ShowProgress 1, LOF(f), "Loading..."
        Header = Input(6, f)
        If Left(Header, 4) <> "GBST" Then
            MsgBox "ERROR Invalid File", vbExclamation, "ERROR"
            Close f
            Exit Sub
        End If
        Do Until EOF(f)
            head = Input(4, f)
            If head = "" Then Exit Do
            UpDateProgress Loc(f), "Loading Section " & head & "..."
            Get f, , length
            'Debug.Print Head & ": " & Length
            Select Case UCase(head)
            Case "TILE"
                bTile = True
                NumOfTiles = length / 4096
                
                iTmp = NumOfTiles - 1
                
                ReDim Tiles(iTmp)
                
                For i = 0 To NumOfTiles - 1 Step 4
                    For z = 0 To 63
                        Get f, , Tiles(i).Info(z)
                        Get f, , Tiles(i + 1).Info(z)
                        Get f, , Tiles(i + 2).Info(z)
                        Get f, , Tiles(i + 3).Info(z)
                    Next
                Next
            Case "PPAL"
                bPpal = True
                NumOfPals = length / 1024
                
                ReDim PPal(NumOfPals - 1)
                
                For h = 1 To NumOfPals / 64
                    For c = 0 To 255
                        For z = 0 To 63
                            X = ((h - 1) * 64) + z
                            Get f, , PPal(X).Info(c)
                        Next
                    Next
                Next
            Case "PALX"
                bPalx = True
                NumOfPalx = length / 2
                
                ReDim Palx(NumOfPalx - 1)
                
                Get f, , Palx()
            Case "SPRX"
                bSprx = True
                NumOfSprx = length / 8
                
                ReDim Sprx(NumOfSprx - 1)
                
                Get f, , Sprx
            Case "SPRG"
                bSprg = True
                Sprg = Space(length)
                
                Get f, , Sprg
            Case "SPRB"
                bSprb = True
                Get f, , Sprb
            Case "FONB"
                bFonb = True
                Get #f, , Fonb.iFontCount

                ReDim Fonb.iBase(Fonb.iFontCount - 1)

                Get f, , Fonb.iBase()
            Case "DELS"
                bDels = True
                LenOfDels = length
                
                Dels = Space(length)
                Get #f, , Dels
            Case "DELX"
                bDelx = True
                LenOfDelx = length
                e = 0
                i = 0
                Do Until e >= length
                    ReDim Preserve Delx(i)
                    Get f, , Delx(i).iSpriteNum
                    Get f, , Delx(i).iDelCount
                    Get f, , Delx(i).iPad
                    If Delx(i).iDelCount > 0 Then
                        ReDim Delx(i).iData(Delx(i).iDelCount - 1)
                        Get f, , Delx(i).iData
                    End If
                    e = e + (Delx(i).iDelCount * 2) + 4
                    i = i + 1
                Loop
            Case "CARI"
                bCari = True
                LenOfCari = length
                e = 0
                i = 0
                Do Until e >= length
                    ReDim Preserve Cari(i)
                    Get f, , Cari(i).iModel
                    Get f, , Cari(i).iSprite
                    Get f, , Cari(i).iWidth
                    Get f, , Cari(i).iHeight
                    Get f, , Cari(i).iNum_Remaps
                    Get f, , Cari(i).iPassengers
                    Get f, , Cari(i).iWreck
                    Get f, , Cari(i).iRating
                    Get f, , Cari(i).iFront_Wheel_Offset
                    Get f, , Cari(i).iRear_Wheel_Offset
                    Get f, , Cari(i).iFront_Window_Offset
                    Get f, , Cari(i).iRear_Window_Offset
                    Get f, , Cari(i).iInfo_flags
                    Get f, , Cari(i).iInfo_flags_2
                    e = e + 14
                    If Cari(i).iNum_Remaps > 0 Then
                        ReDim Cari(i).iRemap(Cari(i).iNum_Remaps - 1)
                        Get f, , Cari(i).iRemap()
                        e = e + Cari(i).iNum_Remaps
                    End If
                    Get f, , Cari(i).iNum_Doors
                    e = e + 1
                    If Cari(i).iNum_Doors > 0 Then
                        ReDim Cari(i).tDoors(Cari(i).iNum_Doors - 1)
                        Get #f, , Cari(i).tDoors()
                        e = e + (Cari(i).iNum_Doors * 2)
                    End If
                    i = i + 1
                Loop
            Case "SPEC"
                bSpec = True
                Spec = Space(length)

                Get f, , Spec
            Case "PALB"
                bPalb = True
                Get f, , Palb
            Case "RECY"
                bRecy = True
                ReDim Recy(length - 1)

                Get f, , Recy
            Case "OBJI"
                bObji = True
                Obji = Space(length)

                Get f, , Obji
            Case Else
                Seek f, Loc(1) + length + 1
            End Select
        Loop
    Close f
    CloseProgress
End Sub

Public Sub SaveSTY(sFile)
    On Error Resume Next
    Dim f As String
    Dim i As Long
    Dim z As Long
    Dim h As Long
    Dim c As Long
    Dim X As Long
    
    ShowProgress 1, 14, "Please wait..."
    Kill sFile & ".bak"
    FileCopy sFile, sFile & ".bak"
    Kill sFile
    On Error GoTo 0
    
    f = FreeFile
    Open sFile For Binary As f
        Put f, , CStr("GBST")
        Put f, , CInt(600)
        
        If bTile Then
            Put f, , CStr("TILE")
            Put f, , CLng(CLng(NumOfTiles) * 4096)
            UpDateProgress 1, "Saving TILE..."
            For i = 0 To NumOfTiles - 1 Step 4
                For z = 0 To 63
                    Put f, , Tiles(i).Info(z)
                    Put f, , Tiles(i + 1).Info(z)
                    Put f, , Tiles(i + 2).Info(z)
                    Put f, , Tiles(i + 3).Info(z)
                Next
            Next
        End If
        If bPpal Then
            Put f, , CStr("PPAL")
            Put f, , CLng(CLng(NumOfPals) * 1024)
            
            UpDateProgress 2, "Saving PPAL..."
            For h = 1 To NumOfPals / 64
                For c = 0 To 255
                    For z = 0 To 63
                        X = ((h - 1) * 64) + z
                        Put f, , PPal(X).Info(c)
                    Next
                Next
            Next
        End If
        If bSprb Then
            Put f, , CStr("SPRB")
            Put f, , CLng(12)

            UpDateProgress 3, "Saving SPRB..."
            Put f, , Sprb
        End If
        
        If bFonb Then
            Put f, , CStr("FONB")
            Put f, , CLng((Fonb.iFontCount * 2) + 2)

            UpDateProgress 4, "Saving FONB..."
            Put f, , Fonb.iFontCount
            For i = 0 To Fonb.iFontCount - 1
                Put f, , Fonb.iBase(i)
            Next
        End If
        
        If bDelx Then
            Put f, , CStr("DELX")
            Put f, , CLng(LenOfDelx)
            
            UpDateProgress 5, "Saving DELX..."
            For i = 0 To UBound(Delx)
                Put f, , Delx(i).iSpriteNum
                Put f, , Delx(i).iDelCount
                Put f, , Delx(i).iPad
                Put f, , Delx(i).iData()
            Next
        End If
        If bDels Then
            Put f, , CStr("DELS")
            Put f, , CLng(Len(Dels))
            
            UpDateProgress 6, "Saving DELS..."
            Put f, , Dels
        End If
        If bPalx Then
            Put f, , CStr("PALX")
            Put f, , CLng((UBound(Palx) + 1) * 2)
            
            UpDateProgress 7, "Saving PALX..."
            For i = 0 To UBound(Palx)
                Put f, , CInt(Palx(i))
            Next
        End If
        If bObji Then
            Put f, , CStr("OBJI")
            Put f, , CLng(Len(Obji))
            
            UpDateProgress 8, "Saving OBJI..."
            Put f, , CStr(Obji)
            
        End If
        If bRecy Then
            Put f, , CStr("RECY")
            Put f, , CLng(UBound(Recy) + 1)
            
            UpDateProgress 9, "Saving RECY..."
            Put f, , Recy
        End If
        If bSprg Then
            
            Put f, , CStr("SPRG")
            Put f, , CLng(Len(Sprg))
            
            UpDateProgress 10, "Saving SPRG..."
            Put f, , CStr(Sprg)
        End If
        
        If bSprx Then
            Put f, , CStr("SPRX")
            Put f, , CLng((UBound(Sprx) + 1) * 8)
            
            UpDateProgress 11, "Saving SPRX..."
            Put f, , Sprx()
        End If
        
        If bPalb Then
            Put f, , CStr("PALB")
            Put f, , CLng(Len(Palb))
            
            UpDateProgress 12, "Saving PALB..."
            Put f, , Palb
        End If
        
        If bCari Then
            Put f, , CStr("CARI")
            Put f, , CLng(LenOfCari)
            
            UpDateProgress 13, "Saving CARI..."
            For i = 0 To UBound(Cari)
                Put f, , Cari(i).iModel
                Put f, , Cari(i).iSprite
                Put f, , Cari(i).iWidth
                Put f, , Cari(i).iHeight
                Put f, , Cari(i).iNum_Remaps
                Put f, , Cari(i).iPassengers
                Put f, , Cari(i).iWreck
                Put f, , Cari(i).iRating
                Put f, , Cari(i).iFront_Wheel_Offset
                Put f, , Cari(i).iRear_Wheel_Offset
                Put f, , Cari(i).iFront_Window_Offset
                Put f, , Cari(i).iRear_Window_Offset
                Put f, , Cari(i).iInfo_flags
                Put f, , Cari(i).iInfo_flags_2
                Put f, , Cari(i).iRemap
                Put f, , Cari(i).iNum_Doors
                Put f, , Cari(i).tDoors
            Next
        End If
        If bSpec Then
            Put f, , CStr("SPEC")
            Put f, , CLng(Len(Spec))
            
            UpDateProgress 14, "Saving SPEC..."
            Put f, , CStr(Spec)
        End If
    Close f
    CloseProgress
End Sub

Public Function GetCol(Pal, Col) As Long
    With PPal(Pal).Info(Col)
        GetCol = RGB(.rgbRed, .rgbGreen, .rgbBlue)
    End With
End Function

Public Sub RenderSprite(idx, PicBox As PictureBox, Optional Pal As Integer = -1)
    Dim tmp As String
    Dim tmprgb As RGBQUAD
    Dim o As Long
    
    If Pal <> -1 Then
        m_Pal = Pal
    Else
        m_Pal = Palx(Palb.pals(0) + idx)
    End If
    
    o = Sprx(idx).offset + 1
    m_Width = Sprx(idx).Width
    m_Height = Sprx(idx).Height
    
    If m_Trans Then
        tmprgb = PPal(m_Pal).Info(0)
        PPal(m_Pal).Info(0).rgbRed = 255
        PPal(m_Pal).Info(0).rgbGreen = 0
        PPal(m_Pal).Info(0).rgbBlue = 255
    End If
    
    SaveSprite sTempDir & "temp.bmp", idx, Pal
    
    If m_Trans Then
        PPal(m_Pal).Info(0) = tmprgb
    End If
    On Error Resume Next
    PicBox = LoadPicture(sTempDir & "temp.bmp")
    On Error GoTo 0
End Sub


Public Function GetDeltaString(deltaNumber As Integer, spriteIdx As Integer) As String
  Dim offset As Long
  Dim deltaIdx As Integer
  Dim deltaLength As Integer
  Dim totalLength As Long
  Dim nOffset As Long
  Dim i As Long
  Dim o As Long
  
  GetDeltaString = ""
  
  '##################################
  'Calculate the starting offset of the current cars delta set
  offset = 1
  deltaIdx = -1
  For i = 0 To UBound(Delx)
    If spriteIdx = Delx(i).iSpriteNum Then
      deltaIdx = i
      Exit For
    Else
      For o = 0 To UBound(Delx(i).iData)
        offset = offset + Delx(i).iData(o)
      Next
    End If
  Next
  
  'Make sure its a valid delta
  If deltaIdx = -1 Then Exit Function
  If deltaNumber > Delx(deltaIdx).iDelCount - 1 Then Exit Function
  '##################################


  '##################################
  nOffset = 0
  For i = 0 To deltaNumber - 1
    nOffset = nOffset + Delx(deltaIdx).iData(i)
  Next
  GetDeltaString = Mid(Dels, offset + nOffset, Delx(deltaIdx).iData(i))
  '##################################
End Function

Public Sub RenderDelta(deltaNumber As Integer, spriteIdx As Integer, PicBox As PictureBox, PalIdx As Integer)
  Dim dOffset As Long
  Dim gOffset As Long
  Dim X As Integer, Y As Integer, c As Integer
  Dim deltainfo As String
  Dim deltaLength As Long
  Dim Bit As Long
  
  'Grab the delta we want to draw
  deltainfo = GetDeltaString(deltaNumber, spriteIdx)
  
  dOffset = 0
  gOffset = 1
  
  'Ok, now for the drawing
  Do Until deltainfo = ""
    gOffset = 1
    
    'Get the offset of the current 'bit' within the delta is to be drawn
    dOffset = GetVal(Mid(deltainfo, 1, 2)) + dOffset
    'Work out the x/y co-ords from the offset
    X = dOffset Mod 256
    Y = dOffset \ 256
    
    'Get the length of the delta
    deltaLength = Asc(Mid(deltainfo, 3, 1))
    gOffset = gOffset + deltaLength + 3
    
    'Draw the bits of the delta onto the picture
    For c = 0 To deltaLength - 1
      Bit = Asc(Mid(deltainfo, c + 4, 1))
      SetPixelV PicBox.hdc, X + c, Y, GetCol(PalIdx, Bit)
    Next
    dOffset = dOffset + deltaLength
    deltainfo = Mid(deltainfo, gOffset)
  Loop
End Sub

Public Sub RenderTile(idx, PicBox As PictureBox)
    Dim tmprgb As RGBQUAD
    
    m_Pal = Palx(idx)
    
    m_Width = 64: m_Height = 64
    
    PicBox.Cls

    If m_Trans Then
        tmprgb = PPal(m_Pal).Info(0)
        PPal(m_Pal).Info(0).rgbRed = 255
        PPal(m_Pal).Info(0).rgbGreen = 0
        PPal(m_Pal).Info(0).rgbBlue = 255
    End If
    
    SaveTile sTempDir & "temp.bmp", idx
    
    If m_Trans Then
        PPal(m_Pal).Info(0) = tmprgb
    End If
    
    PicBox.Picture = LoadPicture(sTempDir & "temp.bmp")
End Sub

Public Sub SaveTile(sFile, idx)
    Dim Y As Integer
    Dim b As String
    For Y = 0 To 63
        b = Tiles(idx).Info(Y) & b
    Next
    
    Dim bytes() As Byte
    bytes = b
    
    SaveBMP CStr(sFile), 64, 64, Palx(idx), CStr(b)
    b = ""
End Sub

Public Sub SaveSprite(sFile, idx, Optional Pal As Integer = -1)
    Dim sPic As String
    Dim offset As Long
    Dim w As Long
    Dim h As Long
    Dim i As Long
    
    offset = Sprx(idx).offset + 1
    w = Sprx(idx).Width
    h = Sprx(idx).Height
    
    Fixwidth w
    
    For i = 0 To h - 1
        sPic = Mid(Sprg, offset + (256 * i), w) & sPic
    Next
    
    On Error Resume Next
    Kill sFile
    On Error GoTo 0
    
    If Pal = -1 Then
        Pal = CInt(Palx(Palb.pals(0) + idx))
    End If
    
    SaveBMP CStr(sFile), CLng(Sprx(idx).Width), CLng(Sprx(idx).Height), Pal, sPic
End Sub

Public Sub SaveDelta(sFile As String, deltaNumber As Integer, spriteIdx As Integer, Optional Pal As Integer = -1)
  Dim sPic As String
  Dim offset As Long
  Dim xOffset As Long
  Dim w As Long
  Dim h As Long
  Dim i As Long
  Dim deltainfo As String
  Dim deltaLength As Long
  Dim stmp As String

  offset = Sprx(spriteIdx).offset + 1
  w = Sprx(spriteIdx).Width
  h = Sprx(spriteIdx).Height
  
  Fixwidth w
  
  For i = 0 To h - 1
    sPic = sPic & Mid(Sprg, offset + (256 * i), w)
  Next
  
  Dim dOffset As Long
  
  'Grab the delta we want to draw
  deltainfo = GetDeltaString(deltaNumber, spriteIdx)
  
  dOffset = 0
  
  'Ok, now for the drawing
  Do Until deltainfo = ""
    
    'Get the offset of the current 'bit' within the delta is to be drawn
    dOffset = GetVal(Mid(deltainfo, 1, 2)) + dOffset
    xOffset = ((dOffset \ 256) * w) + (dOffset Mod 256) + 2
    'Get the length of the delta
    deltaLength = Asc(Mid(deltainfo, 3, 1))
    
    'Draw the bits of the delta onto the picture
    Mid(sPic, xOffset, deltaLength) = Mid(deltainfo, 4, deltaLength)
    dOffset = dOffset + deltaLength
    deltainfo = Mid(deltainfo, deltaLength + 4)
  Loop
  
  For i = 0 To h - 1
    stmp = Mid(sPic, (i * w) + 1, w) & stmp
  Next
  
  sPic = stmp
  
  On Error Resume Next
  Kill sFile
  On Error GoTo 0
  
  If Pal = -1 Then
    Pal = CInt(Palx(Palb.pals(0) + spriteIdx))
  End If
  
  SaveBMP CStr(sFile), CLng(Sprx(spriteIdx).Width), CLng(Sprx(spriteIdx).Height), Pal, sPic
End Sub

Public Sub ImportPalette(sFile, PalIdx)
    Dim tmparray() As String
    Dim f As String
    Dim tmp As String
    Dim i As Long
    
    f = FreeFile
    Open sFile For Input As 1
        Line Input #f, tmp
        If tmp <> "JASC-PAL" Then
            Close 1
            Exit Sub
        End If
        Line Input #f, tmp
        Line Input #f, tmp
        For i = 0 To 255
            Line Input #f, tmp
            tmparray() = Split(tmp, " ")
            PPal(PalIdx).Info(i).rgbRed = tmparray(0)
            PPal(PalIdx).Info(i).rgbGreen = tmparray(1)
            PPal(PalIdx).Info(i).rgbBlue = tmparray(2)
        Next i
    Close f
End Sub

Public Property Get GetNumOfTiles() As Integer
    GetNumOfTiles = NumOfTiles
End Property

Public Property Get GetNumOfPals() As Integer
    GetNumOfPals = NumOfPals
End Property

Public Property Get GetNumOfPalx() As Integer
    GetNumOfPalx = NumOfPalx
End Property

Public Property Get GetNumOfSprx() As Integer
    GetNumOfSprx = NumOfSprx
End Property

Public Property Get DrawTransparent() As Boolean
    DrawTransparent = m_Trans
End Property

Public Property Let DrawTransparent(ByVal vNewValue As Boolean)
    m_Trans = vNewValue
End Property

Public Property Get lWidth() As Integer
    lWidth = m_Width
End Property

Public Property Get lHeight() As Integer
    lHeight = m_Height
End Property

Public Property Get lPal() As Integer
    lPal = m_Pal
End Property

Public Function GetBits(SprNum) As String
    Dim offset As Long
    Dim w As Long
    Dim h As Long
    Dim Y As Long
    Dim tmp As String
    
    offset = Sprx(SprNum).offset + 1
    w = Sprx(SprNum).Width
    h = Sprx(SprNum).Height
    
    Fixwidth w
    For Y = 0 To h - 1
        tmp = Mid(Sprg, offset + (256 * Y), w) & tmp
    Next
    GetBits = tmp
End Function

Public Sub SetDeltaBits(deltaNumber As Integer, spriteIdx As Integer, bits As String)
  Dim sPic As String
  Dim sDelta() As String
  Dim deltaDiff(256, 256, 1) As Byte
  Dim offset As Long
  Dim w As Long
  Dim h As Long
  Dim i As Long
  Dim tmp As String
  Dim X As Long
  Dim Y As Long
  Dim delcount As Long
  Dim BigDelta As String
  Dim z As Long
  Dim o As Long
  
  offset = Sprx(spriteIdx).offset + 1
  w = Sprx(spriteIdx).Width
  h = Sprx(spriteIdx).Height

  Fixwidth w

  For i = 0 To h - 1
    sPic = sPic & Mid(Sprg, offset + (256 * i), w)
  Next

  For i = h - 1 To 0 Step -1
    tmp = tmp & Mid(bits, (h * i) + 1, w)
  Next

  bits = tmp

  Dim f As Integer, dOffset As Integer
  dOffset = 1
  offset = 1
  For i = 1 To Len(bits)
    If Mid(bits, i + 1, 1) <> Mid(sPic, i + 1, 1) Then
      Do While Mid(bits, i + 1, 1) <> Mid(sPic, i + 1, 1)
        X = i Mod w
        Y = i \ w
        deltaDiff(X, Y, 0) = 1
        deltaDiff(X, Y, 1) = CByte(Asc(Mid(bits, i + 1, 1)))
        i = i + 1
      Loop
      i = i - 1
    End If
  Next i

  Dim delData(256, 256) As Byte

  offset = -1
  delcount = 0
  For Y = 0 To h - 1
    For X = 0 To w - 1
      If deltaDiff(X, Y, 0) = 1 Then
        If offset > 0 Then
          delcount = delcount + 1


          delData(delcount, 0) = offset Mod 256
          delData(delcount, 1) = offset \ 256
          delData(delcount, 2) = 1
          delData(delcount, 3) = deltaDiff(X, Y, 1)
          offset = 0
        Else
          delData(delcount, 2) = delData(delcount, 2) + 1
          delData(delcount, 2 + delData(delcount, 2)) = deltaDiff(X, Y, 1)
        End If
      Else
        offset = offset + 1
      End If
    Next
    offset = offset + (256 - w)
  Next

  BigDelta = ""
  For i = 1 To delcount
    Debug.Print delData(i, 0), delData(i, 1), delData(i, 2)
    BigDelta = BigDelta & Chr(delData(i, 0)) & Chr(delData(i, 1)) & Chr(delData(i, 2))
    For z = 0 To delData(i, 2) - 1
      BigDelta = BigDelta & Chr(delData(i, 3 + z))
    Next
  Next
  
  'recreate the dels and delx sections
  offset = 0
  For i = 0 To UBound(Delx)
    If spriteIdx = Delx(i).iSpriteNum Then
      For o = 0 To deltaNumber - 1
        offset = offset + Delx(i).iData(o)
      Next
      Dels = Mid(Dels, 1, offset) & BigDelta & Mid(Dels, offset + Len(BigDelta) + 1)
      Delx(i).iData(deltaNumber) = Len(BigDelta)
      Exit For
    Else
      For o = 0 To UBound(Delx(i).iData)
        offset = offset + Delx(i).iData(o)
      Next
    End If
  Next
End Sub

Public Sub SetBits(SprNum As Integer, bits)
    Dim offset As Long
    Dim w As Long
    Dim h As Long
    Dim Y As Long
    offset = Sprx(SprNum).offset + 1
    w = Sprx(SprNum).Width
    h = Sprx(SprNum).Height
    
    Fixwidth w
    
    For Y = 0 To h - 1
        Mid(Sprg, offset + (256 * (h - (Y + 1))), w) = Mid(bits, (Y * w) + 1, w)
    Next
End Sub

Public Sub SetBitsTile(TileNum, bits)
    Dim Y As Long
    For Y = 0 To 63 - 1
        Tiles(TileNum).Info(Y) = Mid(bits, (Y * 64) + 1, 64)
    Next
End Sub

Public Function GetSpriteHeight(idx) As Long
    GetSpriteHeight = Sprx(idx).Height
End Function

Public Function GetSpriteWidth(idx) As Long
    GetSpriteWidth = Sprx(idx).Width
End Function

Public Function GetSpriteOffset(idx) As Long
    GetSpriteOffset = Sprx(idx).offset
End Function

Public Sub Fixwidth(iWidth)
    Dim fmod As Long
    fmod = iWidth Mod 4
    
    If fmod = 0 Then
     iWidth = iWidth
    ElseIf fmod = 2 Then
     iWidth = iWidth + 2
    ElseIf fmod = 1 Or fmod = 3 Then
     iWidth = iWidth + (5 - fmod)
    End If
    
    If iWidth Mod 2 > 0 Then
     iWidth = iWidth - 1
    End If
End Sub

Private Sub ResetStuff()
    bTile = False
    bPpal = False
    bPalx = False
    bPalb = False
    bSprg = False
    bSprx = False
    bSprb = False
    bDels = False
    bDelx = False
    bFonb = False
    bCari = False
    bObji = False
    bRecy = False
    bSpec = False
End Sub

Public Function SpriteNumFromModelNum(iModelNum) As Integer
    Dim i As Long
    SpriteNumFromModelNum = 0
    For i = 0 To UBound(Cari)
        If Cari(i).iModel = iModelNum Then
            Exit Function
        End If
        If Cari(i).iSprite = 1 Then
            SpriteNumFromModelNum = SpriteNumFromModelNum + 1
        End If
    Next
End Function

'  Dim sPic As String
'  Dim sDelta() As String
'  Dim deltaDiff(256, 256, 1) As Byte
'
'  offset = Sprx(spriteIdx).offset + 1
'  w = Sprx(spriteIdx).Width
'  h = Sprx(spriteIdx).Height
'
'  Fixwidth w
'
'  For i = 0 To h - 1
'    sPic = sPic & Mid(Sprg, offset + (256 * i), w)
'  Next
'
'  For i = h - 1 To 0 Step -1
'    tmp = tmp & Mid(bits, (h * i) + 1, w)
'  Next
'
'  bits = tmp
'
'  Dim f As Integer, dOffset As Integer
'  dOffset = 1
'  offset = 1
'  For i = 0 To Len(bits) - 1
'    If Mid(bits, i + 1, 1) <> Mid(sPic, i + 1, 1) Then
'      Do While Mid(bits, i + 1, 1) <> Mid(sPic, i + 1, 1)
'        x = (i Mod w) - 1
'        y = i \ w
'        deltaDiff(x, y, 0) = 1
'        deltaDiff(x, y, 1) = CByte(Asc(Mid(bits, i + 1, 1)))
'        i = i + 1
'      Loop
'      i = i - 1
'    End If
'  Next i
'
'  Dim delData(1000, 256) As String
'
'  offset = 1
'  delCount = 0
'  For y = 0 To h - 1
'    For x = 0 To w - 1
'      If deltaDiff(x, y, 0) = 1 Then
'        If offset > 0 Then
'          delCount = delCount + 1
'
'          delData(delCount, 0) = x
'          delData(delCount, 1) = y
'          delData(delCount, 2) = 1
'          delData(delCount, 3) = deltaDiff(x, y, 1)
'          offset = 0
'        Else
'          delData(delCount, 2) = delData(delCount, 2) + 1
'          delData(delCount, 2 + delData(delCount, 2)) = deltaDiff(x, y, 1)
'        End If
'      Else
'        offset = offset + 1
'      End If
'    Next
'    offset = offset + (256 - w)
'  Next
'
'  For i = 1 To delCount
'    BigDelta = BigDelta & Chr(delData(i, 0)) & Chr(delData(i, 1)) & Chr(delData(i, 2))
'    For z = 1 To delData(i, 2)
'      BigDelta = BigDelta & Chr(delData(i, 2 + z))
'    Next
'  Next

'''my code
'    If Mid(bits, i, 1) <> Mid(sPic, i, 1) Then
'      'redim the array +1
'      On Error Resume Next
'      ReDim Preserve sDelta(UBound(sDelta) + 1)
'      If Err Then
'        ReDim sDelta(0)
'      End If
'      On Error GoTo 0
'      f = UBound(sDelta)
'
'      Do Until Mid(bits, i, 1) = Mid(sPic, i, 1)
'        'add the bits to the current array
'        sDelta(f) = sDelta(f) + Mid(bits, i, 1)
'        i = i + 1
'      Loop
'
'      i = i - 2
'
'      x = (i - dOffset) Mod w
'      y = (i - dOffset) \ w
'
'      Debug.Print i Mod w, i \ w, Len(sDelta(f))
'      sDelta(f) = Chr(x) & Chr(y) & Chr(Len(sDelta(f))) & sDelta(f)
'
'      dOffset = i
'
'      i = i + 1
'    End If
'  Next
'
'  For i = 0 To UBound(sDelta)
'    BigDelta = BigDelta & sDelta(i)
'  Next
'
'  'recreate the dels and delx sections
'  offset = 1
'  For i = 0 To UBound(Delx)
'    If spriteIdx = Delx(i).iSpriteNum Then
'      For o = 0 To deltaNumber - 1
'        offset = offset + Delx(i).iData(o)
'      Next
'      Mid(Dels, offset, Delx(i).iData(deltaNumber)) = BigDelta
'      Delx(i).iData(deltaNumber) = Len(BigDelta)
'    Else
'      For o = 0 To UBound(Delx(i).iData)
'        offset = offset + Delx(i).iData(o)
'      Next
'    End If
'  Next

