Attribute VB_Name = "modBMP"
Option Explicit

Public Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCount As Long, lpBits As Any) As Long
Public Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long


Public Type BITMAPFILEHEADER
        bfType As String * 2
        bfSize As Long
        bfReserved1 As Integer
        bfReserved2 As Integer
        bfOffBits As Long
End Type

Public Type BITMAPINFOHEADER
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Public Type tBitmap
    fHeader As BITMAPFILEHEADER
    iHeader As BITMAPINFOHEADER
End Type


Public Sub SaveBMP(sFile As String, Width As Long, Height As Long, PalIdx As Integer, bits As String)
    Dim cBMP As tBitmap
    Dim f As String

    cBMP.fHeader.bfType = "BM"
    cBMP.fHeader.bfSize = 1078 + Len(bits)
    cBMP.fHeader.bfOffBits = 1078

    cBMP.iHeader.biSize = Len(cBMP.iHeader)
    cBMP.iHeader.biWidth = Width
    cBMP.iHeader.biHeight = Height
    cBMP.iHeader.biPlanes = 1
    cBMP.iHeader.biBitCount = 8
    cBMP.iHeader.biCompression = 0
    cBMP.iHeader.biSizeImage = 0
    cBMP.iHeader.biXPelsPerMeter = 0
    cBMP.iHeader.biYPelsPerMeter = 0
    cBMP.iHeader.biClrUsed = 256
    cBMP.iHeader.biClrImportant = 256
    
    f = FreeFile
    Open sFile For Binary As f
        Put #f, , cBMP
        Put #f, , PPal(PalIdx).Info()
        Put #f, , CStr(bits)
    Close f
End Sub

Public Function LoadBMP(sFile, hnd) As String
    Dim cBMP As tBitmap
    Dim cPal(255) As RGBQUAD
    Dim bits As String
    Dim f As String
    Dim tmp As String
    
    bits = FileLen(sFile) - 1078
    f = FreeFile
    tmp = Space(bits)
    GetBitmapBits hnd, CLng(bits), tmp
    LoadBMP = tmp
End Function

Public Function cBlue(Colour As Long) As Integer
    cBlue = Int((Colour / (2 ^ 16))) And 255
End Function

Public Function cGreen(Colour As Long) As Integer
    cGreen = Int((Colour / (2 ^ 8))) And 255
End Function

Public Function cRed(Colour As Long) As Integer
    cRed = Colour And 255
End Function
